# std::runtime_error

From cppreference.com
< cpp‎ | error

Defined in header `<stdexcept>` |  |
class runtime_error; |  |

Defines a type of object to be thrown as exception. It reports errors that are due to events beyond the scope of the program and can not be easily predicted.

Exceptions of type `std::runtime_error` are thrown by the following standard library components: std::locale::locale and std::locale::combine.

In addition, the standard exception types std::range_error, std::overflow_error, std::underflow_error, std::regex_error, and std::system_error are derived from `std::runtime_error`.

Inheritance diagram

### Member functions

(constructor) | constructs the exception object (public member function)

## std::runtime_error::runtime_error

explicit runtime_error( const std::string& what_arg ); | (1) |
explicit runtime_error( const char* what_arg ); | (2) | (since C++11)

Constructs the exception object with `what_arg` as explanatory string that can be accessed through what().

Because copying `std::exception` is not permitted to throw exceptions, this message is typically stored internally as a separately-allocated reference-counted string. This is also why there is no constructor taking `std::string&&`: it would have to copy the content anyway.

### Parameters

what_arg | - | explanatory string

### Exceptions

May throw std::bad_alloc

## Inherited from std::exception

### Member functions

(destructor) [virtual] | destructs the exception object (virtual public member function of `std::exception`)
what [virtual] | returns an explanatory string (virtual public member function of `std::exception`)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/error/runtime_error&oldid=85886"